function    [] = compute_alphas(ireload,i_freq)

if i_freq == 1,
    dscale = 1200;
else
    dscale = 100;
end

for isample = 1 : 3,
    malphas     = zeros(2,8);
    mtstat      = zeros(2,8);
    
    % Load data
    if i_freq == 1,                 % -- Monthly data
        if isample == 1,
            if ireload == 1,
                mret_ff         = xlsread('../../data/returns.xlsx','Fama and French factors','B8:D1046')/100;
                vrf             = xlsread('../../data/returns.xlsx','Fama and French factors','E8:E1046')/100;
                mret_ind        = [xlsread('../../data/returns.xlsx','Industry returns','B8:F1046')/100 xlsread('../../data/returns.xlsx','Health returns','B8:D1046')/100];

                save ret_drugs_devices_monthly_s1
            else
                load ret_drugs_devices_monthly_s1
            end
        elseif isample == 2,
            if ireload == 1,
                mret_ff         = xlsread('../../data/returns.xlsx','Fama and French factors','B236:D1046')/100;
                vrf             = xlsread('../../data/returns.xlsx','Fama and French factors','E236:E1046')/100;
                mret_ind        = [xlsread('../../data/returns.xlsx','Industry returns','B236:F1046')/100 xlsread('../../data/returns.xlsx','Health returns','B236:D1046')/100];

                save ret_drugs_devices_monthly_s2
            else
                load ret_drugs_devices_monthly_s2
            end        
        else
            if ireload == 1,
                mret_ff         = xlsread('../../data/returns.xlsx','Fama and French factors','B416:D1046')/100;
                vrf             = xlsread('../../data/returns.xlsx','Fama and French factors','E416:E1046')/100;
                mret_ind        = [xlsread('../../data/returns.xlsx','Industry returns','B416:F1046')/100 xlsread('../../Data/returns.xlsx','Health returns','B416:D1046')/100];

                save ret_drugs_devices_monthly_s3
            else
                load ret_drugs_devices_monthly_s3
            end          
        end
    else                        % -- Annual data
        if isample == 1,
            if ireload == 1,
                mret_ff         = xlsread('../../Data/returns.xlsx','Fama and French factors - A','B2:D87')/100;
                vrf             = xlsread('../../Data/returns.xlsx','Fama and French factors - A','E2:E87')/100;
                mret_ind        = [xlsread('../../Data/returns.xlsx','Industry returns - A','B2:F87')/100 xlsread('../../Data/returns.xlsx','Health returns - A','B2:D87')/100];

                save ret_drugs_devices_annual_s1
            else
                load ret_drugs_devices_annual_s1
            end
        elseif isample == 2,
            if ireload == 1,
                mret_ff         = xlsread('../../Data/returns.xlsx','Fama and French factors - A','B21:D87')/100;
                vrf             = xlsread('../../Data/returns.xlsx','Fama and French factors - A','E21:E87')/100;
                mret_ind        = [xlsread('../../Data/returns.xlsx','Industry returns - A','B21:F87')/100 xlsread('../../Data/returns.xlsx','Health returns - A','B21:D87')/100];

                save ret_drugs_devices_annual_s2
            else
                load ret_drugs_devices_annual_s2
            end        
        else
            if ireload == 1,
                mret_ff         = xlsread('../../Data/returns.xlsx','Fama and French factors - A','B36:D87')/100;
                vrf             = xlsread('../../Data/returns.xlsx','Fama and French factors - A','E36:E87')/100;
                mret_ind        = [xlsread('../../Data/returns.xlsx','Industry returns - A','B36:F87')/100 xlsread('../../Data/returns.xlsx','Health returns - A','B36:D87')/100];

                save ret_drugs_devices_annual_s3
            else
                load ret_drugs_devices_annual_s3
            end              
        end
    end

    % Compute excess returns
    [dT,dN]         = size(mret_ind);
    mret_ind_exc    = mret_ind - vrf * ones(1,dN);

    % Compute basic alphas for all industries 
    for i = 1 : dN,
        vres            = nwest(mret_ind_exc(:,i),[ones(dT,1) mret_ff(:,1)],0);
        malpha(1,i)     = vres.beta(1)*dscale;
        mtstat(1,i)     = vres.tstat(1);
        vres            = nwest(mret_ind_exc(:,i),[ones(dT,1) mret_ff(:,:)],0);
        malpha(2,i)     = vres.beta(1)*dscale;
        mtstat(2,i)     = vres.tstat(1);
    end
    
    disp('CAPM and FF alphas')
    disp([malpha(1,:);mtstat(1,:);malpha(2,:);mtstat(2,:)])
    disp('Number of observations')
    disp(dT)
    
    % Compute alphas controlling for the HC factor
    for i = 1 : 3,
        vres            = nwest(mret_ind_exc(:,5+i),[ones(dT,1) mret_ff(:,1) mret_ind_exc(:,4)],0);
        malpha_HC(1,i)  = vres.beta(1)*dscale;
        mtstat_HC(1,i)  = vres.tstat(1);        
        mbeta_HC(1,i)   = vres.beta(end);
        mbtstat_HC(1,i) = vres.tstat(end);        
        vres            = nwest(mret_ind_exc(:,5+i),[ones(dT,1) mret_ff(:,:) mret_ind_exc(:,4)],0);
        malpha_HC(2,i)  = vres.beta(1)*dscale;
        mtstat_HC(2,i)  = vres.tstat(1);        
        mbeta_HC(2,i)   = vres.beta(end);
        mbtstat_HC(2,i) = vres.tstat(end);        
    end
    
    disp('CAPM+HC factor and FF+HC factor alphas')
    disp([malpha_HC(1,:);mtstat_HC(1,:);malpha_HC(2,:);mtstat_HC(2,:)])
    disp('HC exposure')
    disp([mbeta_HC(1,:);mbtstat_HC(1,:);mbeta_HC(2,:);mbtstat_HC(2,:)])
    disp('Number of observations')
    disp(dT)
end







