% -------------------------------------------------------------------------
% Koijen, Philipson, and Uhlig (2014): "Financial Health Economics"
% 
% The code generates Table 3 and Figure 2
% 
% -------------------------------------------------------------------------

%% Reset Matlab
clear all; close all; clc

%% Word list to search for

% The dictionary in Table 2
% aList   = {'government' 'governments' 'governmentprogram' 'governmentprograms'  'politicalrisk' 'governmental' 'governmentalprogram' 'governmentalprograms'  ...
%                 'political' 'politics' 'politicalreform' 'politicalreforms' 'governmentalregulations' 'governmentalregulation'...
%                 'pricecontrol'  'pricecontrols'  'pricerestriction' 'pricerestrictions' 'governmentintervention' 'governmentinterventions' ...
%                 'priceconstraint' 'priceconstraints' 'legislation' 'legislatory' 'regulation' 'regulations' 'regulatory' 'law' 'laws' 'patentlaw' 'patentlaws' ...
%                 'fiscalimbalances' 'fiscalimbalance' 'debtceiling' 'governmentdeficit' 'governmentdeficits' 'subsidy' 'subsidies' 'reimbursement' 'reimbursements' 'governmentapproval' ...
%                 'congress' 'senate' 'government-sponsored' 'government-approved' 'federal' 'federalfunds' 'regulatorycompliance' 'regulatorydelay' 'regulatorydelays' 'politicalrisks' ...
%                 'governmentdebt' 'governmentdebts' 'governmentregulation' 'governmentregulations' 'congressional' 'legislative' 'litigation'}';

% The dictionary in Table 2, augmented with government-specific words
aList   = {'government' 'governments' 'governmentprogram' 'governmentprograms'  'politicalrisk' 'governmental' 'governmentalprogram' 'governmentalprograms'  ...
                'political' 'politics' 'politicalreform' 'politicalreforms' 'governmentalregulations' 'governmentalregulation'...
                'pricecontrol'  'pricecontrols'  'pricerestriction' 'pricerestrictions' 'governmentintervention' 'governmentinterventions' ...
                'priceconstraint' 'priceconstraints' 'legislation' 'legislatory' 'regulation' 'regulations' 'regulatory' 'law' 'laws' 'patentlaw' 'patentlaws' ...
                'fiscalimbalances' 'fiscalimbalance' 'debtceiling' 'governmentdeficit' 'governmentdeficits' 'subsidy' 'subsidies' 'reimbursement' 'reimbursements' 'governmentapproval' ...
                'congress' 'senate' 'government-sponsored' 'government-approved' 'federal' 'federalfunds' 'regulatorycompliance' 'regulatorydelay' 'regulatorydelays' 'politicalrisks' ...
                'governmentdebt' 'governmentdebts' 'governmentregulation' 'governmentregulations' 'congressional' 'legislative' ...
                'medicare'  'litigation' 'medicarereform' 'medicaid' 'medicaidreform' 'ppaca' 'cms' 'carereform' 'healthcarereform' 'nhs' 'fda','careact'}';

disp('Word list of interest')
aList   = sort(aList);
disp(sort(aList))

%% Word counts
vcount_sum_HC_06            = word_count('../../Data/2006_HC.txt',aList);
vcount_sum_NonHC_06         = word_count('../../Data/2006_nonHC.txt',aList);
vcount_sum_HC_12            = word_count('../../Data/2012_HC.txt',aList);
vcount_sum_NonHC_12         = word_count('../../Data/2012_nonHC.txt',aList);

%% Summary statistics
figure;bar([2006 2012],[vcount_sum_NonHC_06(2) vcount_sum_HC_06(2); vcount_sum_NonHC_12(2) vcount_sum_HC_12(2)])
legend('Non-health care firms','Health-care firms')

disp('----------------------- 2006 --------------------------------------')
disp('Health care stocks');disp([vcount_sum_HC_06(1)/50 vcount_sum_HC_06(2)])
disp('Non-health care stocks');disp([vcount_sum_NonHC_06(1)/50 vcount_sum_NonHC_06(2)])

disp('----------------------- 2012 --------------------------------------')
disp('Health care stocks');disp([vcount_sum_HC_12(1)/50 vcount_sum_HC_12(2)])
disp('Non-health care stocks');disp([vcount_sum_NonHC_12(1)/50 vcount_sum_NonHC_12(2)])






