function    df  = SA_optim_newplots_2014_10_06(vP_in)

%% Set parameters
% Labor Share ...dtheta_labshare ...  added 2014-09-29
% CYrat ... the ratio of cons to output ... moved here 2014-10-06
% Numerical parameter ... weight ... on "old solution", added 2014_10_06
% The average vplot_t = weight*vpmy_t + (1-weight)*vpsi_t,added 2014_10_06
global dsigma dxi dh_bar dphi domega dM_low dy_t dgamma da_t dnu ioutput dchi dtheta_labshare CYrat
global vpmy_t vdy_t va_t profits_t cons_e_t vpsi_t weight vplot_t
global FNpiece
% Preferences
dxi         = vP_in(1);

% Health
dh_bar      = vP_in(2);

% Technology
da_0        = vP_in(3);
dnu         = vP_in(4);

DEBUG_SA_optim = 0;
HORIZON = 20;

BlackWhitePlots = 1;
if BlackWhitePlots,
    lstyle = ['o-k ';'*--k';'k-  '];
else
    lstyle = ['o-b';'*-r';'b- '];
end;

% options     = optimset('Display','off'); 
% I commented out this line since optimset for some reason stopped working.
% I instead inserted the following line. Harald, Nov. 2013
options     = optimoptions('fsolve','Display','off');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%   STILL DOING SOME DIAGNOSTICS ON THESE:
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Some parameters:
OBJECTIVE = 2;
% for OBJECTIVE = 1:
RDweight = 50; % 10; % in the criterion function
SCALE1   = 1;
% for OBJECTIVE = 2:
RDweight2 = 400;
SCALE2    = 1e21;
% for OBJECTIVE = 3:
RDweight3 = 10000;
SCALE3    = 1e24;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
switch OBJECTIVE
    case 1
        SCALE = SCALE1;
    case 2
        SCALE = SCALE2;
        % disp('  A: Objective 2');
    case 3
        SCALE = SCALE3;
end;



% % ORIGINAL CODE: shares of GDP net of investment
% %% Target values
% ds_RD_1990      = 0.003963982;
% ds_RD_2000      = 0.005767032;
% ds_RD_2010      = 0.008390216;
% ds_RD_1990_data = 0.00371269;
% ds_RD_2000_data = 0.00505615;
% vHC_share       = [0.060335;0.084660;0.110880;0.146574;0.168352;0.203748];
% vRD_share       = [ds_RD_1990;ds_RD_2000;ds_RD_2010];
% % END OF ORIGINAL CODE
 
%% Target values
ds_RD_1990      = 0.3173/100;
ds_RD_2000      = 0.4708/100;
ds_RD_2010      = 0.6986/100;
ds_RD_1990_data = 0.3162/100;
ds_RD_2000_data = 0.4156/100;
ds_RD_2006_data = 0.5965/100;
vHC_share       = [5.1331;7.2254;9.1822;11.8023;13.8364;17.8564]/100;
% vRD_share       = [ds_RD_1990;ds_RD_2000;ds_RD_2010];
vRD_share       = [ds_RD_1990_data;ds_RD_2000_data;ds_RD_2010];
 
%% Solve model 
iproblem    = 0;
da_t        = da_0;
vpmy_t      = zeros(HORIZON+1,1);
vpsi_t      = zeros(HORIZON+1,1); % added 2014_09_29: share of output, see equation (20) in 2014_09_29_HU
vplot_t     = zeros(HORIZON+1,1); % weighted average, = weight*vpmy_t + (1-weight)*vpsi_t, added 2014_10_06
vdy_t       = zeros(HORIZON+1,1); % will also now be = weight*"old" + (1-weight)*"new"
va_t        = zeros(HORIZON+2,1);
va_t(1)     = log(da_t);
profits_t   = zeros(HORIZON+1,1); 
cons_e_t    = zeros(HORIZON+1,1);
if DEBUG_SA_optim,
   %  disp('debug 0');
   %  disp([iproblem,ioutput]);
end;
for t = 0 : 5,
    dy_t                    = dgamma^t; % labor-produced output
    dq_t                    = da_t;     % q(t), the quality or inverse-of-marg-cost for health
    dp_t                    = dphi/dq_t;% p(t), the price, given as markup times marg costs
    vpmy_t(t+1)             = dtheta_labshare*(1-dxi)/(1-dxi*dsigma) - (1-dsigma)/(1-dxi*dsigma)*dxi*dh_bar*dp_t;
                            % lambda(t)=p(t)*m(t)/gamma^t, the share of gross
                            % labor income spent on medical care, equation
                            % (21) in 2015_05_19H.  Notice the introduction
                            % of the labor share dtheta_labshare.
    vpsi_t(t+1)             = CYrat * vpmy_t(t+1)/(1 + (1 - 1/dphi)*vpmy_t(t+1));  
                            % added 2014_10_09: share of output, see equation (24) in 2015_05_19H 
    vplot_t(t+1)            = weight*vpmy_t(t+1) + (1-weight)*vpsi_t(t+1);
                            % added 2014_10_06 to allow smooth transition
                            % from "old" to "new" solution
    profits_t(t+1)          = vpmy_t(t+1)*dy_t*(1 - 1/dphi); % = pi(t). This follows from equation (16) in 2014_10_29
    if t > 0,
        dd_init             = dd_t; % initial guess for R&D effort d in period t
    else
        dd_init             = 0.001*dy_t; % initial guess for R&D effort d in period 0
    end
    
    % [dd_t,dfval,iexitflag]  = fsolve(@solve_RD_2014_10_06,dd_init,options); 
    % solving for the R&D effort per the equation (23) in 2014_00_29_HU
    ldd_init = log(dd_init);
    [ldd_t,dfval,iexitflag]  = fsolve(@solve_RDlogD_2014_10_09,ldd_init,options); 
    dd_t = exp(ldd_t);
    
    if iexitflag ~= 1,
        iproblem    = 1;
    end
    
    % Before 2014_09_29: share of labor output
    % vdy_t(t+1)              = dd_t/dy_t;
    % share of measured total output, incl. investment and profits.
    % To allow smooth transition between "old" and "new", do a weighted average:
    vdy_t(t+1)              = weight * (dd_t/dy_t) + ...
        (1-weight) * ( ( dd_t/dy_t) * CYrat * (1/(1 + (1 - 1/dphi)*vpmy_t(t+1))) );  
    da_t                    = (da_t^dnu + (dd_t)^dnu)^(1/dnu);
    va_t(t+2)               = log(da_t);
    
    cons_e_t(t+1)           = profits_t(t+1) - dd_t; % entrepr. cons., see equation (11) in 2013_04_29, when kappa = 1
end;
if DEBUG_SA_optim,
   disp('debug 1');
   disp([iproblem,ioutput]);
   % disp([vpmy_t(1),vpmy_t(6),vdy_t(4),vdy_t(6)]);

   % size(vpmy_t)
   % size(vpsi_t)
   % size(vplot_t)
   % size(vdy_t)
   % size(va_t)
   % size(cons_e_t)
   
   % disp('    vpmy,    vpsi,    vplot,    vdy,     va,      cons_e:');
   % disp([vpmy_t(1:6,1),vpsi_t(1:6,1),vplot_t(1:6,1),vdy_t(1:6,1),va_t(1:6,1),cons_e_t(1:6,1)]);
   
   disp('    vpmy,    vpsi,    vdy,     va,      cons_e:');
   disp([vpmy_t(1:6,1),vpsi_t(1:6,1),vdy_t(1:6,1),va_t(1:6,1),cons_e_t(1:6,1)]);
end;
if iproblem == 1,
    df  = 100; % NaN;
else
    % 2014_09_29: problem used to be:
    % df  = abs(vpmy_t(1)-vHC_share(1)) + abs(vpmy_t(6)-vHC_share(6)) + 10*abs(vdy_t(4) - ds_RD_1990) + 10*abs(vdy_t(6) - ds_RD_2010);
    % ...but the appropriate comparison should be to the share of total OUTPUT,
    % including profits of the health sector, not just labor-generated
    % output.  So, replace vpmy by vpsi ...
    % ... though, to allow a smooth transition from "old" to "new"
    % solution, use vplot_t, which is a weighted average.
    switch OBJECTIVE
    case 1
        df  = abs(vplot_t(1)-vHC_share(1)) + abs(vplot_t(6)-vHC_share(6)) + RDweight*abs(vdy_t(4) - ds_RD_1990) + RDweight*abs(vdy_t(6) - ds_RD_2010);
    case 2
        df  = ( abs(vplot_t(1)-vHC_share(1)) )^2 + ( abs(vplot_t(6)-vHC_share(6)) )^2 + ...
            ( RDweight2*abs(vdy_t(4) - ds_RD_1990) )^2 + ( RDweight2*abs(vdy_t(6) - ds_RD_2010) )^2;
        % disp('  B: Objective 2');
    case 3
        df  = ( abs(vplot_t(1)-vHC_share(1)) )^2 + ( abs(vplot_t(6)-vHC_share(6)) )^2 + ...
            ( RDweight3*abs(vdy_t(4) - ds_RD_1990) )^2 + ( RDweight3*abs(vdy_t(6) - ds_RD_2010) )^2;
        % disp('  B: Objective 2');
    end;
    % 2014_09_29: ... introduce a check for complex numbers:
    if max([max(imag(vplot_t)),max(imag(vdy_t))]) > 0,
        df = 100;
    end;
end
df = df*SCALE;

if ioutput  == 1,
    DOPAUSE = 0;
    DOESP = 1;
    DOENLARGE = 1;
    % Before 2014_09_29:
    % hndl = plot([1960:10:2010],100*vpmy_t(1:6),lstyle(1,:), ...
    %     [1960:10:2010],100*vHC_share(1:6),lstyle(2,:));
    % ... but it should be share of total output, so
    hndl = plot([1960:10:2010],100*vplot_t(1:6),lstyle(1,:), ...
        [1960:10:2010],100*vHC_share(1:6),lstyle(2,:));
    grid;
    legend('Model','Data','Location','NorthWest');
    % xlabel('Date');
    ylabel('Percent of GDP');
    title('Health spending share: data vs model');
    FN=[FNpiece,'_share'];
    dispprint(hndl,FN,DOPAUSE,DOESP,DOENLARGE);
    hndl = plot([1960:10:2010],100*vdy_t(1:6),lstyle(1,:),...
        [1960:10:2010],[NaN;NaN;NaN;100*ds_RD_1990_data;100*ds_RD_2000_data;100*ds_RD_2010],lstyle(2,:));
    grid;
    legend('Model','Data','Location','NorthWest');
    % xlabel('Date');
    ylabel('Percent of GDP');
    title('R&D spending share: data vs model');
    FN=[FNpiece,'_RD'];
    dispprint(hndl,FN,DOPAUSE,DOESP,DOENLARGE);
    
    
    h_fig = figure;
    subplot(2,1,1);
    % Before 2014_09_29:
    % hndl = plot([1960:10:2010],100*vpmy_t(1:6),lstyle(1,:), ...
    %    [1960:10:2010],100*vHC_share(1:6),lstyle(2,:));
    % ... but it should be share of total output, so
    hndl = plot([1960:10:2010],100*vplot_t(1:6),lstyle(1,:), ...
       [1960:10:2010],100*vHC_share(1:6),lstyle(2,:));
    grid;
    legend('Model','Data','Location','NorthWest');
    % xlabel('Date');
    ylabel('Percent of GDP');
    title('Health spending share: data vs model');
    enlargeB;
    subplot(2,1,2);
    hndl = plot([1960:10:2010],100*vdy_t(1:6),lstyle(1,:),...
        [1960:10:2010],[NaN;NaN;NaN;100*ds_RD_1990_data;100*ds_RD_2000_data;100*ds_RD_2010],lstyle(2,:));
    grid;
    legend('Model','Data','Location','NorthWest');
    % xlabel('Date');
    ylabel('Percent of GDP');
    title('R&D spending share: data vs model');
    enlargeB;
    FN=[FNpiece,'_Ralph'];
    print(h_fig,FN,'-depsc');
    if DOPAUSE,
        disp('Hit any key when ready...');
        pause;
    end;
    
    figure;
    
    hndl = plot([1960:10:2010],va_t(1:6),lstyle(3,:));
    title('Technological level log(a(t))');
    ylabel('va(t)');
    FN=[FNpiece,'_vat'];
    dispprint(hndl,FN,DOPAUSE,DOESP,DOENLARGE);
    
    disp('Health spending (model and data)')
    % Before 2014_09_29:
    % [vpmy_t(1:6) vHC_share(1:6)]
    % ... but it should be share of total output, so vpsi_t
    % ... but we shall use the weighted average, to allow smooth
    % transition from "old" to "new" solution.
    [vplot_t(1:6) vHC_share(1:6)]

    disp('R&D spending (model and real data)')
    [vdy_t(1:6) [NaN;NaN;NaN;ds_RD_1990_data;ds_RD_2000_data;ds_RD_2010]]

    
    lr_share_subs_old = (1-dxi)/(1-dsigma*dxi);
    lr_share_subs_new = CYrat*( (1-dsigma*dxi)/((1-dxi)*dtheta_labshare) + 1 - (1.0/dphi))^(-1);
    lr_share_subs     = weight*lr_share_subs_old + (1-weight)*lr_share_subs_new;
    
    lr_share_nosubs_old = (1-dxi);
    lr_share_nosubs_new = CYrat*( 1.0         /((1-dxi)*dtheta_labshare) + 1 - (1.0/dphi))^(-1);
    lr_share_nosubs     = weight*lr_share_nosubs_old + (1-weight)*lr_share_nosubs_new;
    
    disp('Long-run share with subsidies')
    disp(lr_share_subs);

    disp('Long-run share without subsidies')
    disp(lr_share_nosubs);
    
    if iproblem == 1,
        disp('Problem in optimization')
    else
        disp('Optimization correct')
    end
    da_t        = da_0;
    vpmy_t      = zeros(6,1);
    vdy_t       = zeros(6,1);
    va_t(1)     = log(da_t);
    for t = 0 : HORIZON,
        dy_t                    = dgamma^t;
        dq_t                    = da_t;
        dp_t                    = dphi/dq_t;
        vpmy_t(t+1)             = dtheta_labshare*(1-dxi)/(1-dxi*dsigma) - (1-dsigma)/(1-dxi*dsigma)*dxi*dh_bar*dp_t;
        % lambda(t)=p(t)*m(t)/gamma^t, the share of gross
        % labor income spent on medical care, equation
        % (21) in 2015_05_19H.  Notice the introduction
        % of the labor share dtheta_labshare.
        vpsi_t(t+1)             = CYrat * vpmy_t(t+1)/(1 + (1 - 1/dphi)*vpmy_t(t+1));  
                                % added 2014_10_09: share of output, see equation (24) in 2015_05_19H 
        vplot_t(t+1)            = weight*vpmy_t(t+1) + (1-weight)*vpsi_t(t+1);
                                % added 2014_10_06 to allow smooth transition
                                % from "old" to "new" solution
        if t > 0,
            dd_init             = dd_t;
        else
            dd_init             = 0.001*dy_t;
        end
        
        % [dd_t,dfval,iexitflag]  = fsolve(@solve_RD_2014_10_06,dd_init,options);
        
        ldd_init = log(dd_init);
        [ldd_t,dfval,iexitflag]  = fsolve(@solve_RDlogD_2014_10_09,ldd_init,options); 
        dd_t = exp(ldd_t);
            
        if iexitflag ~= 1,
            iproblem    = 1;
        end
        
        % Before 2014_09_29: share of labor output
        % vdy_t(t+1)              = dd_t/dy_t;
        % share of measured total output, incl. investment and profits.
        % To allow smooth transition between "old" and "new", do a weighted average:
        vdy_t(t+1)              = weight * (dd_t/dy_t) + ...
               (1-weight) * ( ( dd_t/dy_t) * CYrat * (1/(1 + (1 - 1/dphi)*vpmy_t(t+1))) );  
        
        da_t                    = (da_t^dnu + (dd_t)^dnu)^(1/dnu);
        va_t(t+2)               = log(da_t);
    end
        
    % Before 2014_09_29:
    % hndl = plot([1960:10:2010+15*10],100*vpmy_t);
    % ... but it should be share of total output, so vpsi_t
    % To allow smooth transition between "old" and "new, use vplot_t
    hndl = plot([1960:10:1960+HORIZON*10],100*vplot_t,lstyle(3,:));
    grid;
    % legend('Model','Data','Location','NorthWest');
    % xlabel('Date');
    ylabel('Percent of GDP');
    title('Health spending share: long-run');
    FN=[FNpiece,'_share_longrun'];
    dispprint(hndl,FN,DOPAUSE,DOESP,DOENLARGE);
    
    % vpmy_t
    % vpsi_t
    vplot_t
        
    hndl = plot([1960:10:1960+HORIZON*10],100*vdy_t,lstyle(3,:));
    grid;
    % legend('Model','Data','Location','NorthWest');
    % xlabel('Date');
    ylabel('Percent of GDP');
    title('R&D spending share: long-run');
    FN=[FNpiece,'_RD_longrun'];
    dispprint(hndl,FN,DOPAUSE,DOESP,DOENLARGE);

end






