% longrunshares calculates the long run share in the absence of gov intervention,
% given parameters.

DO_SET_PARAMETERS = 1;

% setting parameters, copied from driver_2014_10_10_mult_om.m.
% Adjust if parameters change!

if DO_SET_PARAMETERS, %else: start from vX_opt
    % Rbar_tenyears     = 1.04^10;
    % Qbar_tenyears     = 1.09^10;
    
    % OMEGA_VALUE_1       = 0.1;
    % OMEGA_VALUE_2       = 0.2;
    
    % theta_1 = ((Qbar_tenyears/Rbar_tenyears) - 1)*(1-OMEGA_VALUE_1)/OMEGA_VALUE_1;
    % betta_tilde_1 = 1.0/(Rbar_tenyears * (1 - OMEGA_VALUE_1 + OMEGA_VALUE_1 * theta_1 ));
    
    %theta_2 = ((Qbar_tenyears/Rbar_tenyears) - 1)*(1-OMEGA_VALUE_2)/OMEGA_VALUE_2;
    % betta_tilde_2 = 1.0/(Rbar_tenyears * (1 - OMEGA_VALUE_2 + OMEGA_VALUE_2 * theta_2 ));
    
    dtheta_labshare = 0.8; % 0.8;
    CYrat = 3/4; % 3/4; % to correct output for "missing investment"
    weight = 0; % weight on "old" solution, can be useful for homotopy approach
    
    
    % Government subsidy
    dsigma      = 0.5;
    
    % Government risk
    dphi        = 3;
    dphi_low    = 1;
    
    dchi        = 0.5;
    
    
    
    % Growth
    dgamma      = 1.35;
    
    vX_optA =         [ 0.3133; 8.8151; 8.6733; 0.4175]; % same as above
    vX_optB =1.0e-04 *[ 0.1688; 0.2167; 0.4363; 0.0313]; % a very slight correction
    vX_Guess = vX_optA + vX_optB;  % best value 2014-10-10C, crit = 4.6545e-06, OBJECTIVE = 2;
    
    vX_opt = vX_Guess;
    
end;





vP_in       = vX_opt;

% Setting parameters needed for the calculation below, then doing the
% calculations.
% This is a piece of code copied from SA_optim_newplots_2014_10_10.m

dxi         = vP_in(1);

% Health
dh_bar      = vP_in(2);

% Technology
da_0        = vP_in(3);
dnu         = vP_in(4);


lr_share_subs_old = (1-dxi)/(1-dsigma*dxi);
lr_share_subs_new = CYrat*( (1-dsigma*dxi)/((1-dxi)*dtheta_labshare) + 1 - (1.0/dphi))^(-1);
lr_share_subs     = weight*lr_share_subs_old + (1-weight)*lr_share_subs_new;

lr_share_nosubs_old = (1-dxi);
lr_share_nosubs_new = CYrat*( 1.0         /((1-dxi)*dtheta_labshare) + 1 - (1.0/dphi))^(-1);
lr_share_nosubs     = weight*lr_share_nosubs_old + (1-weight)*lr_share_nosubs_new;

disp('Long-run share with subsidies')
disp(lr_share_subs);

disp('Long-run share without subsidies')
disp(lr_share_nosubs);

